## fcitx-4.2.9.9-5.src.tar.gz

=== src/ui/CMakeLists.txt ===
add_subdirectory(cairostuff)
add_subdirectory(classic)
add_subdirectory(kimpanel)

=== tools/cli/CMakeLists.txt ===
set(createPYMB_SOURCES
  createPYMB.c
  ${PROJECT_SOURCE_DIR}/src/im/pinyin/pyParser.c
  ${PROJECT_SOURCE_DIR}/src/im/pinyin/pyMapTable.c
  ${PROJECT_SOURCE_DIR}/src/im/pinyin/PYFA.c
  ${PROJECT_SOURCE_DIR}/src/im/pinyin/sp.c
  )

set(mb2org_SOURCES
  mb2org.c
  pyTools.c
  ${PROJECT_SOURCE_DIR}/src/im/pinyin/pyParser.c
  ${PROJECT_SOURCE_DIR}/src/im/pinyin/pyMapTable.c
  ${PROJECT_SOURCE_DIR}/src/im/pinyin/PYFA.c
  ${PROJECT_SOURCE_DIR}/src/im/pinyin/sp.c
  )

set(readPYBase_SOURCES
  readPYBase.c
  pyTools.c
  )

set(readPYMB_SOURCES
  readPYMB.c
  pyTools.c
  )

set(mb2txt_SOURCES
  mb2txt.c
  )

set(txt2mb_SOURCES
  txt2mb.c
  )

set(scel2org_SOURCES
  scel2org.c
  )

add_executable(createPYMB ${createPYMB_SOURCES})
add_executable(readPYBase ${readPYBase_SOURCES})
add_executable(readPYMB ${readPYMB_SOURCES})
add_executable(mb2org ${mb2org_SOURCES})
add_executable(mb2txt ${mb2txt_SOURCES})
add_executable(txt2mb ${txt2mb_SOURCES})
add_executable(scel2org ${scel2org_SOURCES})

target_link_libraries(createPYMB fcitx-config fcitx-utils)
target_link_libraries(readPYBase fcitx-config)
target_link_libraries(readPYMB fcitx-config)
target_link_libraries(mb2org fcitx-config)
target_link_libraries(mb2txt fcitx-config fcitx-utils)
target_link_libraries(txt2mb fcitx-config fcitx-utils)
target_link_libraries(scel2org ${LIBICONV_LIBRARIES})

install(TARGETS createPYMB readPYBase readPYMB mb2org mb2txt
  txt2mb scel2org DESTINATION "${bindir}")

if(NOT _ENABLE_DBUS)
  add_executable(fcitx-remote fcitx-remote.c)
  target_link_libraries(fcitx-remote fcitx-utils)
  install(TARGETS fcitx-remote DESTINATION ${bindir})
endif()

fcitx_translate_add_sources(
  createPYMB.c
  pyTools.c
  fcitx-remote.c
  scel2org.c
  mb2org.c
  readPYMB.c
  readPYBase.c
  txt2mb.c
  mb2txt.c
  pyTools.h
  )

=== src/im/keyboard/CMakeLists.txt ===
include_directories (
  ${LIBINTL_INCLUDE_DIR}
  ${LIBICONV_INCLUDE_DIR}
  )
set(FCITX_KEYBOARD_LINK_LIBS ${LIBICONV_LIBRARIES})
if(ENABLE_XKB)
  include_directories(${LIBXML2_INCLUDE_DIR})
  set(FCITX_KEYBOARD_LINK_LIBS ${FCITX_KEYBOARD_LINK_LIBS} ${LIBXML2_LIBRARIES})
endif()

set(FCITX_KEYBOARD_SOURCES
  keyboard.c
  keyboardconfig.c
  )

if(ENABLE_XKB)
  set(FCITX_KEYBOARD_SOURCES ${FCITX_KEYBOARD_SOURCES} isocodes.c)
  set(FCITX_KEYBOARD_LINK_LIBS ${FCITX_KEYBOARD_LINK_LIBS} PkgConfig::JsonC)
endif()

fcitx_add_addon_full(keyboard DESC
  SOURCES ${FCITX_KEYBOARD_SOURCES}
  LINK_LIBS ${FCITX_KEYBOARD_LINK_LIBS} XKBCommon::XKBCommon
  EXTRA_PO isocodes.c isocodes.h keyboard.h)

=== src/im/qw/CMakeLists.txt ===
set(FCITX_QUWEI_SOURCES
  qw.c
  )

fcitx_add_addon_full(qw
  SOURCES ${FCITX_QUWEI_SOURCES}
  IM_CONFIG qw.conf)

=== src/module/chttrans/CMakeLists.txt ===
set(FCITX_CHTTRANS_SOURCES
  chttrans.c)
if(ENABLE_OPENCC)
  set(FCITX_CHTTRANS_SOURCES ${FCITX_CHTTRANS_SOURCES} chttrans-opencc.c)
endif()

fcitx_add_addon_full(chttrans SCAN SCAN_PRIV DESC
  SOURCES ${FCITX_CHTTRANS_SOURCES}
  HEADERS chttrans.h
  EXTRA_PO chttrans-opencc.c)

=== src/module/clipboard/CMakeLists.txt ===
set(FCITX_CLIPBOARD_SOURCES
  clipboard.c
  clipboardconfig.c
  )

# do not disable clipboard-x11 even if x11 is diabled, since fcitx-scanner and
# fcitx_add_addon_full is capable for doing this.
if(1)
  set(FCITX_CLIPBOARD_SOURCES ${FCITX_CLIPBOARD_SOURCES} clipboard-x11.c)
endif()

fcitx_add_addon_full(clipboard SCAN SCAN_PRIV DESC
  SOURCES ${FCITX_CLIPBOARD_SOURCES}
  HEADERS clipboard.h
  EXTRA_PO clipboard-x11.c)

=== src/module/spell/CMakeLists.txt ===
set(FCITX_SPELL_SOURCES
  spell.c
  spell-custom.c
  spell-custom-dict.c
  spellconfig.c
  )

if(ENABLE_ENCHANT)
  set(FCITX_SPELL_SOURCES ${FCITX_SPELL_SOURCES} spell-enchant.c)
endif()
if(ENABLE_PRESAGE)
  set(FCITX_SPELL_SOURCES ${FCITX_SPELL_SOURCES} spell-presage.c)
endif()

if (ENABLE_SPELL)
    set(spell_noinstall)
    add_subdirectory(dict)
else()
    set(spell_noinstall NO_INSTALL)
endif()

link_directories(${DL_LIBRARY_DIRS})

fcitx_add_addon_full(spell SCAN SCAN_PRIV DESC
  SOURCES ${FCITX_SPELL_SOURCES}
  HEADERS spell.h
  LINK_LIBS ${DL_LIBRARIES}
  EXTRA_PO spell-enchant.c spell-presage.c
  ${spell_noinstall})

=== src/im/table/data/CMakeLists.txt ===
set(TXT2MB_BIN "${PROJECT_BINARY_DIR}/tools/cli/txt2mb")

set(TABLE_DATA
  "${CMAKE_CURRENT_BINARY_DIR}/db.mb"
  "${CMAKE_CURRENT_BINARY_DIR}/erbi.mb"
  "${CMAKE_CURRENT_BINARY_DIR}/qxm.mb"
  "${CMAKE_CURRENT_BINARY_DIR}/wanfeng.mb"
  "${CMAKE_CURRENT_BINARY_DIR}/wbpy.mb"
  "${CMAKE_CURRENT_BINARY_DIR}/wbx.mb"
  "${CMAKE_CURRENT_BINARY_DIR}/zrm.mb"
  "${CMAKE_CURRENT_BINARY_DIR}/cj.mb"
  )
set(TABLEORG_DATA db.txt erbi.txt qxm.txt wanfeng.txt
  wbpy.txt wbx.txt zrm.txt cj.txt)
set(TABLE_NAME db erbi qxm wanfeng wbpy wbx zrm cj)
set(TABLE_CONF db.conf erbi.conf qxm.conf wanfeng.conf
  wbpy.conf wbx.conf zrm.conf cangjie.conf)
set(TABLE_URL "http://download.fcitx-im.org/data/table.tar.gz")
set(TABLE_TAR ${CMAKE_CURRENT_SOURCE_DIR}/table.tar.gz)

foreach(tableconffile ${TABLE_CONF})
  fcitx_translate_add_apply_source(
    "${CMAKE_CURRENT_SOURCE_DIR}/${tableconffile}.in"
    "${CMAKE_CURRENT_BINARY_DIR}/${tableconffile}")
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${tableconffile}"
    DESTINATION "${pkgdatadir}/table")
endforeach()
add_custom_target(table_data ALL DEPENDS ${TABLE_DATA})

fcitx_download(table-data-download "${TABLE_URL}" "${TABLE_TAR}"
  MD5SUM acb0b112423474ab2c1a22cee590d636)
fcitx_extract(table-data-extract "${TABLE_TAR}" DEPENDS table-data-download
  OUTPUT ${TABLEORG_DATA})

foreach(tblname ${TABLE_NAME})
  add_custom_command(OUTPUT ${tblname}.mb
    DEPENDS ${tblname}.txt "${TXT2MB_BIN}" table-data-extract
    COMMAND "${TXT2MB_BIN}" ${tblname}.txt ${tblname}.mb)
endforeach()

install(FILES ${TABLE_DATA} DESTINATION ${pkgdatadir}/table )

=== src/module/spell/dict/CMakeLists.txt ===
set(DICT_COMP_SRC
  comp_spell_dict.c
  )

add_executable(comp-spell-dict ${DICT_COMP_SRC})
target_link_libraries(comp-spell-dict fcitx-utils)
install(TARGETS comp-spell-dict
  DESTINATION "${addondir}/libexec")

set(SPELL_EN_DICT_VER 20121020)
set(SPELL_EN_DICT "${CMAKE_CURRENT_BINARY_DIR}/en_dict.fscd")
set(SPELL_EN_DICT_SRC "${CMAKE_CURRENT_BINARY_DIR}/en_dict.txt")
set(SPELL_EN_DICT_TAR "en_dict-${SPELL_EN_DICT_VER}.tar.gz")
set(SPELL_EN_DICT_URL
  "http://download.fcitx-im.org/data/en_dict-${SPELL_EN_DICT_VER}.tar.gz")

fcitx_download(spell-en-download "${SPELL_EN_DICT_URL}" "${SPELL_EN_DICT_TAR}"
  MD5SUM 8315f85331e0545c256a46e0cb00f10f)
fcitx_extract(spell-en-extract "${SPELL_EN_DICT_TAR}" DEPENDS spell-en-download
  OUTPUT ${SPELL_EN_DICT_SRC})

set(COMP_SPELL_DICT
  "${PROJECT_BINARY_DIR}/src/module/spell/dict/comp-spell-dict")
add_custom_command(
  OUTPUT "${SPELL_EN_DICT}"
  DEPENDS "${SPELL_EN_DICT_SRC}" "${COMP_SPELL_DICT}" spell-en-extract
  COMMAND "${COMP_SPELL_DICT}" --comp-dict
  "${SPELL_EN_DICT_SRC}" "${SPELL_EN_DICT}")
add_custom_target(spell_en_dict ALL DEPENDS "${SPELL_EN_DICT}")
install(FILES "${SPELL_EN_DICT}" DESTINATION "${pkgdatadir}/spell")

=== PKGBUILD ===
# Maintainer: Felix Yan <felixonmars@archlinux.org>
# Contributor: Andrea Scarpino <andrea@archlinux.org>
# Contributor: csslayer <wengxt AT gmail com>

pkgname=fcitx
pkgdesc="Flexible Context-aware Input Tool with eXtension"
pkgver=4.2.9.9
pkgrel=5
groups=('fcitx-im')
arch=('x86_64')
url="https://fcitx-im.org"
license=('GPL' 'LGPL')
provides=('fcitx-gtk2' 'fcitx-gtk3')
conflicts=('fcitx-gtk2' 'fcitx-gtk3')
replaces=('fcitx-gtk2' 'fcitx-gtk3')
depends=('pango' 'libxinerama' 'gtk-update-icon-cache' 'shared-mime-info'
          'hicolor-icon-theme' 'desktop-file-utils' 'libxkbfile'
          'libxfixes' 'dbus' 'icu' 'libxkbcommon')
optdepends=('enchant: for word predication support'
            'opencc: optional engine to do chinese convert'
            'gettext: for fcitx-po-parser'
            'fcitx-configtool: for configuration (GTK based)')
makedepends=('extra-cmake-modules' 'doxygen' 'gtk3' 'mesa' 'opencc'
             'iso-codes' 'gobject-introspection' 'enchant' 'python' 'glib2-devel')
source=("https://download.fcitx-im.org/$pkgname/$pkgname-${pkgver}_dict.tar.xz"{,.sig})
sha512sums=('d871df84ebb3514b6474000b693246c8e5b198121e9a5a0ca18d478e54cd4144f8dfb58922a004952d26ab3bcfc1f417c446c22d30994ef40875fc2ee3cda441'
            'SKIP')
validpgpkeys=('2CC8A0609AD2A479C65B6D5C8E8B898CBF2412F9')  # Weng Xuetian

prepare() {
  mkdir build

  sed -e 's|enchant/enchant.h|enchant-2/enchant.h|' -i $pkgname-$pkgver/cmake/FindEnchant.cmake
}

build() {
  cd build

  cmake ../$pkgname-$pkgver \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DSYSCONFDIR=/etc \
    -DFORCE_OPENCC=ON \
    -DFORCE_PRESAGE=ON \
    -DFORCE_ENCHANT=ON \
    -DENABLE_TEST=ON \
    -DENABLE_QT=OFF \
    -DENABLE_GTK2_IM_MODULE=OFF \
    -DENABLE_GTK3_IM_MODULE=ON \
    -DENCHANT_INCLUDE_DIR=/usr/include/enchant-2/ \
    -DENCHANT_LIBRARIES=/usr/lib/libenchant-2.so
  make
}

check() {
  cd build
  make test
}

package() {
  cd build
  make DESTDIR="$pkgdir" install
}
